#include "plugin.h"
#include "list"
#include "common.h"
//#include "CRGBA.h"
#include "CWorld.h"
//#include <cstring>
#include <ctime>
//#include "CCutsceneShadow.h"
#include "CPointlight.h"
//#include "CPointlights.h"
#include "CModelInfo.h"

unsigned int ololo = 12345;
unsigned int trololo = 0;

unsigned int		NewPointLightsArray[1337*44];

auto	TextHighPriority = (void(__cdecl *)(const wchar_t *text, unsigned time, bool flag1))0x584300;

auto	StoreShadowToBeRenderedd = (void(__cdecl *)(unsigned char type, unsigned int texture, CVector* posn, float topX, float topY, float rightX, float rightY, short intensity, unsigned char red, unsigned char green, unsigned char blue, float zDistance, bool drawOnWater, float scale, int realTimeShadow, bool drawOnBuildings))0x56E6C0;

/*void StoreShadowToBeRendered(unsigned char type, RwTexture* texture, CVector* posn, float topX, float topY, float rightX, float rightY, short intensity, unsigned char red, unsigned char green, unsigned char blue, float zDistance, bool drawOnWater, float scale, CRealTimeShadow* realTimeShadow, bool drawOnBuildings) {
	((void(__cdecl *)(unsigned char, RwTexture*, CVector*, float, float, float, float, short, unsigned char, unsigned char, unsigned char, float, bool, float, CRealTimeShadow*, bool))0x707390)(type, texture, posn, topX, topY, rightX, rightY, intensity, red, green, blue, zDistance, drawOnWater, scale, realTimeShadow, drawOnBuildings);
}*/


/*
class MyViceCityPlugin {
	static bool __fastcall DynamicSetupLighting(class CEntity *) {
		ActivateDirectional();
		SetAmbientColoursForPedsCarsAndObjects();
		return true;
	}

	static void __fastcall DynamicRemoveLighting(class CEntity *, int, bool) {
		SetAmbientColours();
		DeActivateDirectional();
	}

public:
	MyViceCityPlugin() {
		//       CBuilding
		//plugin::patch::SetPointer(0x6865C4, DynamicSetupLighting);
		//plugin::patch::SetPointer(0x6865C8, DynamicRemoveLighting);
		//       CObject
		plugin::patch::SetPointer(0x6917D8, DynamicSetupLighting);
		plugin::patch::SetPointer(0x6917DC, DynamicRemoveLighting);
	}
} vcplugin;
*/






using namespace plugin;

class PluginSdkTestProject1
{
public:

	class PedShadow
	{
	public:
		CCutsceneShadow *m_pRTShadow;

		PedShadow(CPed *) : m_pRTShadow(nullptr) {}
		~PedShadow() { delete m_pRTShadow; }
	};

	static PedExtendedData<PedShadow> pedShadow;

	static void UpdatePedShadow(CPed *ped, float sideX, float sideY, float displacementX, float displacementY, float frontX, float frontY) 
	{
		CCutsceneShadow *pShadow = pedShadow.Get(ped).m_pRTShadow;
		float _savedVal = ped->m_EventOrThreatPos.x;// ped->m_fEventOrThreatX;
		*reinterpret_cast<CCutsceneShadow **>(&ped->m_EventOrThreatPos.x) = pShadow;
		if (pShadow)
		{
			if (pShadow->IsInitialized())
				pShadow->UpdateForCutscene();
			plugin::Call<0x56D5C0>(ped, sideX, sideY, displacementX, displacementY, frontX, frontY);
		}
		else
			plugin::Call<0x56D9F0>(ped, sideX, sideY, displacementX, displacementY, frontX, frontY);
		ped->m_EventOrThreatPos.x = _savedVal;
	}

	static void CreatePedShadow(CPed *ped, int)
	{
		PedShadow &shadow = pedShadow.Get(ped);
		if (!shadow.m_pRTShadow)
		{
			shadow.m_pRTShadow = new CCutsceneShadow;
			shadow.m_pRTShadow->Create(ped->m_pRwObject, 6, 1, 1, 1);
		}
	}

	static double GenerateLightsAffectingObjectFix(CEntity *entity)//(CVector *vctr)
	{
		//__int16 LightsCounter;
		//int PLOffset;
		//char PointLightType;
		//float MaxRadius;
		//float DeltaX;
		//float MaxRadiusNegative;
		//float DeltaY;
		//float DeltaZ;
		//float ActualRadius;
		//float v12;
		//float v13;
		//float VectorMultiplier;
		//float OffsetVectorX;
		//float OffsetVectorY;
		//float OffsetVectorZ;
		float v19;
		//float PointLightColorB;
		//float PointLightColorG;
		//float PointLightColorR;
		//float OffsetVectorZfloat;
		//float OffsetVectorYfloat;
		//float OffsetVectorXfloat;
		float v27;
		int *cPointLightsNumLights = (int*)(0x9751B0);
		//char *PointLightsArray = (char*)(0x7E4FE0);
		//CPointLight *PointLightsArray = (CPointLight*)(0x7E4FE0);
		CPointLight *PointLightsArray = (CPointLight*)(0x7E4FE0);

		//CPointLight(&PointLightsArray)[32] = *reinterpret_cast<CPointLight(*)[32]>(0x7E4FE0, 0x7E4FE8, 0x7E3FE8);



		static wchar_t  showinfo[MAX_PATH];

		short lightsCounter = 0;
		//int pLOffset = 0;
		v27 = 1.0;
		while (lightsCounter < *cPointLightsNumLights)
		{
			unsigned char pointLightType = PointLightsArray[lightsCounter].m_nType;//(PointLightsArray + PLOffset)->m_nType;//CPointLights::aLights[LightsCounter].m_nType;//PointLightsArray[LightsCounter]->m_nType;//*(PointLightsArray + PLOffset + 0x28);
			if (pointLightType != 3 && pointLightType != 4)
			{
				float pLRange = PointLightsArray[lightsCounter].m_fRange;//*(float *)(PointLightsArray + PLOffset + 0x18);
				CVector pLPos = PointLightsArray[lightsCounter].m_vecPosn;//*(float *)(PointLightsArray + PLOffset);
				CVector entPos = entity->m_placement.pos;
				float deltaX = pLPos.x - entPos.x;
				float pLRangeNegative = -pLRange;
				if (deltaX > pLRangeNegative && deltaX <= pLRange)
				{
					//float pLYPos = *(float *)(PointLightsArray + PLOffset + 0x04);
					float deltaY = pLPos.y - entPos.y;
					if (deltaY > pLRangeNegative && deltaY <= pLRange)
					{
						//float pLZPos = *(float *)(PointLightsArray + PLOffset + 0x08);
						float deltaZ = pLPos.z - entPos.z;
						if (deltaZ > pLRangeNegative && deltaZ <= pLRange)
						{
							float actualDistance = (float)(sqrt(deltaX * deltaX + deltaY * deltaY + deltaZ * deltaZ));
							if (actualDistance <= pLRange)
							{
								if (pointLightType == 2)
								{
									v27 = actualDistance / pLRange * v27;
								}
								else
								{
									float pLDistanceProportion = actualDistance / pLRange;
									float pLIntensity = 1.0;
									if (pLDistanceProportion > 0.5) pLIntensity = (float)(1.0 - (pLDistanceProportion - 0.5) * 2.0);
									//else
										//pLIntensity = 1.0;
									if (actualDistance != 0.0)
									{
										float vectorMultiplier = (float)(1.0 / actualDistance);
										float offsetVectorX = deltaX * vectorMultiplier;
										float offsetVectorY = deltaY * vectorMultiplier;
										float offsetVectorZ = deltaZ * vectorMultiplier;
										
										//swprintf(showinfo, MAX_PATH, L"%d %.1f %.1f %.1f %.1f %.1f", PointLightType, VectorMultiplier, OffsetVectorX, OffsetVectorY, OffsetVectorZ, ActualRadius);
										//TextHighPriority(showinfo, 1000, false);
										
										if (pointLightType == 1)
										{
											v19 = (float)((-(offsetVectorX * PointLightsArray[lightsCounter].m_vecDirection.x + offsetVectorY * PointLightsArray[lightsCounter].m_vecDirection.y + offsetVectorZ * PointLightsArray[lightsCounter].m_vecDirection.z) - 0.5) * 2.0);
											if (0.0 > v19)
												v19 = 0.0;
											pLIntensity = pLIntensity * v19;
										}
										if (pLIntensity > 0.0)
										{
											float pLColorR = pLIntensity * PointLightsArray[lightsCounter].m_fColorRed;
											float pLColorG = pLIntensity * PointLightsArray[lightsCounter].m_fColorGreen;
											float pLColorB = pLIntensity * PointLightsArray[lightsCounter].m_fColorBlue;

											float pLPower = 0.0;
											if (pLColorR > pLPower) pLPower = pLColorR;
											if (pLColorG > pLPower) pLPower = pLColorG;
											if (pLColorB > pLPower) pLPower = pLColorB;


											//float OffsetVectorZfloat = (float)(OffsetVectorZ);
											//float OffsetVectorYfloat = (float)(OffsetVectorY);
											//float OffsetVectorXfloat = (float)(OffsetVectorX);
											
											//swprintf(showinfo, MAX_PATH, L"%d %.1f %.1f %.1f %.1f %.1f", PointLightType, *(float *)(PointLightsArray + PLOffset + 0x1C), *(float *)(PointLightsArray + PLOffset + 0x20), *(float *)(PointLightsArray + PLOffset + 0x24), v13, ActualRadius);
											//TextHighPriority(showinfo, 1000, false);

											//static wchar_t  showinfo[MAX_PATH];
											//swprintf(showinfo, MAX_PATH, L"%.1f %.1f %.1f  %.1f %.1f %.1f", wrld->boundingBox.inf.x, wrld->boundingBox.inf.y, wrld->boundingBox.inf.z, wrld->boundingBox.sup.x, wrld->boundingBox.sup.y, wrld->boundingBox.sup.z);
											//swprintf(showinfo, MAX_PATH, L"%.1f %.1f %.1f  %.1f %.1f %.1f", v25, v24, v23, v22, v21, v20);
											//TextHighPriority(showinfo, 1000, false);




											//swprintf(showinfo, MAX_PATH, L"%.1f %.1f %.1f %.1f %.1f %.1f", FinalSunColorRed, FinalSunColorGreen, FinalSunColorBlue, VectorToSun[(DWORD)(*(float *)(0xA0CFF8))].x, VectorToSun[(DWORD)(*(float *)(0xA0CFF8))].y, VectorToSun[(DWORD)(*(float *)(0xA0CFF8))].z);
											//TextHighPriority(showinfo, 1000, false);

											//ProcessLineOfSight
											CVector pLPosSunAdapted = pLPos;
											//PLPosition.x = *(float *)(PointLightsArray + PLOffset);
											//PLPosition.y = *(float *)(PointLightsArray + PLOffset + 0x04);
											//PLPosition.z = *(float *)(PointLightsArray + PLOffset + 0x08);
											
											if (pointLightType == 5)//ActualRadius > 1000.0)
											{
												pLPosSunAdapted.x = (float)(entPos.x + pLPosSunAdapted.x / 10.0);
												pLPosSunAdapted.y = (float)(entPos.y + pLPosSunAdapted.y / 10.0);
												pLPosSunAdapted.z = (float)(entPos.z + pLPosSunAdapted.z / 10.0);
											}
											
											
											
											CColPoint obstructionColPoint;
											CEntity *obstructionEntity;
											

											//CEntity *Entity = (CEntity*)(&vctr - 0x34);

											//Entity->m_placement.pos;

											//swprintf(showinfo, MAX_PATH, L"%.1f %.1f %.1f %.1f %.1f %.1f", Entity->m_placement.pos.x, Entity->m_placement.pos.y, Entity->m_placement.pos.z, vctr->x, vctr->y, vctr->z);
											//TextHighPriority(showinfo, 1000, false);


											if (!CWorld::ProcessLineOfSight(entity->m_placement.pos, pLPosSunAdapted, obstructionColPoint, obstructionEntity, 1, 0, 0, 1, 0, 1, 1, 1)) // (origin, target, outColPoint, outEntity, buildings, vehicles, peds, objects, dummies, doSeeThroughCheck, doCameraIgnoreCheck, doShootThroughCheck);
											{
												AddAnExtraDirectionalLight((RpWorld*)(0x8100B8), offsetVectorX, offsetVectorY, offsetVectorZ, pLColorR, pLColorG, pLColorB);
												if (PointLightsArray[lightsCounter].m_bGenerateShadows)
												{
													if (entity->m_nType == 3)// && entity == FindPlayerPed())// 1 = building, 2 = vehicle, 3 = ped, 4 = object, 5 = dummy
													{
														short shadowIntensity = (short)(255 * pLPower * pLIntensity);//(short)(5 * (*(short*)(0xA10990) * pLPower) / 8);
														CVector shadowPos = entPos;
														shadowPos.x = (float)(shadowPos.x - 0.9 * offsetVectorX);
														shadowPos.y = (float)(shadowPos.y - 0.9 * offsetVectorY);
														int modelIndex = entity->m_nModelIndex;//pVeh2->physical.entity.m_nModelIndex;
														CColModel *colModel;
														colModel = CModelInfo::ms_modelInfoPtrs[modelIndex]->m_pColModel;//clump.base.m_pColModel;
														float colWidth1 = colModel->m_boundBox.m_vecMin.x - colModel->m_boundBox.m_vecMax.x;//colModel->m_box.m_vInf.x - colModel->m_box.m_vSup.x;
														float colLength1 = (float)((colModel->m_boundBox.m_vecMin.y - CModelInfo::ms_modelInfoPtrs[modelIndex]->m_pColModel->m_boundBox.m_vecMax.y) *0.5);//);//	*0.5);
														float colLength2 = colLength1 - colModel->m_boundBox.m_vecMin.y;
														shadowPos.x = shadowPos.x - colLength2 * entity->m_placement.at.x;//.m_matrix.at.x;
														shadowPos.y = shadowPos.y - colLength2 * entity->m_placement.at.y;
														float actual2DDistance = (float)(sqrt(deltaX * deltaX + deltaY * deltaY));
														float closeDistanceMultiplier = 1.0;
														if (pLDistanceProportion < 0.5) closeDistanceMultiplier = (float)(1.0 + (0.5 - pLDistanceProportion) * 0.5);
														float topX = (-deltaX) / actual2DDistance * closeDistanceMultiplier;
														float topY = (-deltaY) / actual2DDistance * closeDistanceMultiplier;
														float rightX = (float)(0.5 * topY);
														float rightY = (float)(0.5 * -topX);





														/*
														float v16;
														if (entity->m_placement.up.z <= 0.0)
														{
															float colWidth2 = (float)(0.5 * colWidth1); //colWidth1;// (float)(0.5 * colWidth1);
															rightY = -entity->m_placement.right.y * colWidth2;
															rightX = -entity->m_placement.right.x * colWidth2;
														}
														else
														{
															v16 = (float)(0.5 * colWidth1); //colWidth1;// (float)(0.5 * colWidth1);
															rightY = v16 * entity->m_placement.right.y;
															rightX = v16 * entity->m_placement.right.x;
														}
														topY = colLength1 * entity->m_placement.at.y;
														topX = colLength1 * entity->m_placement.at.x;
														*/


														swprintf(showinfo, MAX_PATH, L"%.1f %.1f %.1f %.1f %.1f %.1f %.1f %d", shadowPos.x, shadowPos.y, shadowPos.z, topX, topY, rightX, rightY, shadowIntensity);// , ObstructionEntity->m_nFlags.);
														TextHighPriority(showinfo, 1000, false);
														
														//CShadows::StoreShadowToBeRendered
														//plugin::Call<0x56E6C0>(1, (RwTexture *)(0x97F2EC), &entPos, topX, topY, rightX, rightY, intensity, 0, 0, 0, 4.5, 0, 1.0, 0, 0);
														StoreShadowToBeRenderedd(1, *(unsigned int *)(0x9B5F2C), &shadowPos, topX, topY, rightX, rightY, shadowIntensity, 0, 0, 0, 4.0, 0, 1.0, 0, 1);
													}
													/*else if (entity->m_nType == 2)// 1 = building, 2 = vehicle, 3 = ped, 4 = object, 5 = dummy
													{
														short shadowIntensity = (short)(255 * pLPower * pLIntensity);//(short)(5 * (*(short*)(0xA10990) * pLPower) / 8);
														CVector shadowPos = entPos;
														shadowPos.x = (float)(shadowPos.x - 1.2 * offsetVectorX);
														shadowPos.y = (float)(shadowPos.y - 1.2 * offsetVectorY);
														int modelIndex = entity->m_nModelIndex;//pVeh2->physical.entity.m_nModelIndex;
														CColModel *colModel;
														colModel = CModelInfo::ms_modelInfoPtrs[modelIndex]->m_pColModel;//clump.base.m_pColModel;
														float colWidth1 = colModel->m_boundBox.m_vecMin.x - colModel->m_boundBox.m_vecMax.x;//colModel->m_box.m_vInf.x - colModel->m_box.m_vSup.x;
														float colLength1 = (float)((colModel->m_boundBox.m_vecMin.y - CModelInfo::ms_modelInfoPtrs[modelIndex]->m_pColModel->m_boundBox.m_vecMax.y) *0.5);//);//	*0.5);
														float colLength2 = colLength1 - colModel->m_boundBox.m_vecMin.y;
														shadowPos.x = shadowPos.x - colLength2 * entity->m_placement.at.x;//.m_matrix.at.x;
														shadowPos.y = shadowPos.y - colLength2 * entity->m_placement.at.y;
														//short intensity;
														float rightX;
														float rightY;
														float topX;
														float topY;
														float v16;
														if (entity->m_placement.up.z <= 0.0)
														{
															float colWidth2 = (float)(0.5 * colWidth1); //colWidth1;// (float)(0.5 * colWidth1);
																										//intensity = v6;
															rightY = -entity->m_placement.right.y * colWidth2;
															rightX = -entity->m_placement.right.x * colWidth2;
														}
														else
														{
															v16 = (float)(0.5 * colWidth1); //colWidth1;// (float)(0.5 * colWidth1);
																							//intensity = v6;
															rightY = v16 * entity->m_placement.right.y;
															rightX = v16 * entity->m_placement.right.x;
														}
														topY = colLength1 * entity->m_placement.at.y;
														topX = colLength1 * entity->m_placement.at.x;


														//entPos.x = entity->m_placement.at.x;
														//entPos.y = entity->m_placement.at.y;

														swprintf(showinfo, MAX_PATH, L"%.1f %.1f %.1f %.1f %.1f %.1f %.1f %d", shadowPos.x, shadowPos.y, shadowPos.z, entity->m_placement.up.x, entity->m_placement.up.y, entity->m_placement.right.x, entity->m_placement.right.y, shadowIntensity);// , ObstructionEntity->m_nFlags.);
														TextHighPriority(showinfo, 1000, false);

														//CShadows::StoreShadowToBeRendered
														//plugin::Call<0x56E6C0>(1, (RwTexture *)(0x97F2EC), &entPos, topX, topY, rightX, rightY, intensity, 0, 0, 0, 4.5, 0, 1.0, 0, 0);
														StoreShadowToBeRenderedd(1, *(unsigned int *)(0x97F2EC), &shadowPos, entity->m_placement.up.x, entity->m_placement.up.y, entity->m_placement.right.x, entity->m_placement.right.y, shadowIntensity, 0, 0, 0, 4.0, 0, 1.0, 0, 1);
													}*/






												}
											}
											else
											{
												float ODDeltaX = pLPos.x - obstructionColPoint.m_vPoint.x;
												float ODDeltaY = pLPos.y - obstructionColPoint.m_vPoint.y;
												float ODDeltaZ = pLPos.z - obstructionColPoint.m_vPoint.z;
												float ObstructionDistanceFromLight = (float)(sqrt(ODDeltaX * ODDeltaX + ODDeltaY * ODDeltaY + ODDeltaZ * ODDeltaZ));
												if (ObstructionDistanceFromLight < 500.4)
												{
													//swprintf(showinfo, MAX_PATH, L"%.1f", ObstructionDistanceFromLight);// , ObstructionEntity->m_nFlags.);
													//TextHighPriority(showinfo, 1000, false);
												}
												//if (ObstructionDistanceFromLight < 0.6)
												//{
												//	AddAnExtraDirectionalLight((RpWorld*)(0x8100B8), OffsetVectorX, OffsetVectorY, OffsetVectorZ, PointLightColorR, PointLightColorG, PointLightColorB);
												//}
											}
										}
									}
								}
							}
						}
					}
				}
			}
			//pLOffset += 44;
			++lightsCounter;
		}
		return v27;
	}

	static void CPointLightsAddLightFix(char PLType, CVector PLPosition, CVector PLDirection, float PLRadius, float PLRed, float PLGreen, float PLBlue, char PLFogType, char PLGenerateExtraShadows)
	{
		float DeltaX;
		float DeltaY;
		float DeltaZ;
		float DeltaDist;
		unsigned int PLOffset;
		float *PLPositionOffset;
		float *PLDirectionOffset;
		float PLColorMultiplier;
		CVector *vecCamPos = (CVector*)(0x7E46B8);
		int *CPointLightsNumLights = (int*)(0x9751B0);
		char *PointLightsArray = (char*)(0x7E4FE0);
		float AddLightDistanceCondition = 10000.0;

		DeltaX = PLPosition.x - vecCamPos->x;
		if (DeltaX <= AddLightDistanceCondition && DeltaX > -AddLightDistanceCondition)
		{
			DeltaY = PLPosition.y - vecCamPos->y;
			if (DeltaY <= AddLightDistanceCondition && DeltaY > -AddLightDistanceCondition && *CPointLightsNumLights < 32)
			{
				DeltaZ = PLPosition.z - vecCamPos->z;
				DeltaDist = (float)(sqrt(DeltaZ * DeltaZ + DeltaY * DeltaY + DeltaX * DeltaX));
				if (DeltaDist <= AddLightDistanceCondition)
				{
					PLOffset = 44 * *CPointLightsNumLights;
					*(PointLightsArray + PLOffset + 0x28) = PLType;
					*(PointLightsArray + PLOffset + 0x29) = PLFogType;
					PLPositionOffset = (float *)(PointLightsArray + PLOffset);
					*PLPositionOffset = PLPosition.x;
					PLPositionOffset[1] = PLPosition.y;
					PLPositionOffset[2] = PLPosition.z;
					PLDirectionOffset = (float *)(PointLightsArray + PLOffset + 0x0C);
					*PLDirectionOffset = PLDirection.x;
					PLDirectionOffset[1] = PLDirection.y;
					PLDirectionOffset[2] = PLDirection.z;
					*(float *)(PointLightsArray + PLOffset + 0x18) = PLRadius;
					*(PointLightsArray + PLOffset + 0x2A) = PLGenerateExtraShadows;
					if (DeltaDist > AddLightDistanceCondition*0.75)
					{
						PLColorMultiplier = (float)(1.0 - (DeltaDist / AddLightDistanceCondition - 0.75) * 4.0);
						*(float *)(PointLightsArray + PLOffset + 0x1C) = PLRed * PLColorMultiplier;
						*(float *)(PointLightsArray + PLOffset + 0x20) = PLGreen * PLColorMultiplier;
						*(float *)(PointLightsArray + PLOffset + 0x24) = PLBlue * PLColorMultiplier;
					}
					else
					{
						*(float *)(PointLightsArray + PLOffset + 0x1C) = PLRed;
						*(float *)(PointLightsArray + PLOffset + 0x20) = PLGreen;
						*(float *)(PointLightsArray + PLOffset + 0x24) = PLBlue;
					}
					++*CPointLightsNumLights;
				}
			}
		}
	}

	static bool __fastcall EntitySetupLightingFix(CEntity *entity)
	{
		//char *v1; // ebx
		//float *v2; // ebx
		float v4; // [esp+0h] [ebp-1Ch]
		//int v5; // [esp+4h] [ebp-18h]
		//int v6; // [esp+8h] [ebp-14h]
		//int v7; // [esp+Ch] [ebp-10h]

		//v1 = (char *)ped;
		//ActivateDirectional();
		SetAmbientColoursForPedsCarsAndObjects();
		if (entity->m_nFlags.bRenderScorched)//( ((unsigned __int8)v1[82] >> 4) & 1 )
		{
			WorldReplaceNormalLightsWithScorched((RpWorld*)(0x8100B8), *(float *)(0x690264));
		}
		else
		{
			//v2 = (float *)(v1 + 52);
			//CVector EntityPosVector;
			//EntityPosVector.x = *v2;
			//EntityPosVector.y = v2[1];
			//EntityPosVector.z = v2[2];
			//v5 = *v2;
			//v6 = v2[1];
			//v7 = v2[2];
			v4 = (float)GenerateLightsAffectingObjectFix(entity);
			if (*(float *)(0x690228) == v4)
			{
				SetAmbientAndDirectionalColours(v4);
				return 1;
			}
		}
		return 0;
	}

	static void __fastcall ObjectRemoveLightingFix(CEntity *entity, int, bool)
	{
		if (!entity->m_nFlags.bRenderScorched)
		{
			plugin::Call<0x567430>(); //RemoveVehiclePedLights or CPointLights::RemoveLightsAffectingObject(void)
		}
		SetAmbientColours();
		//DeActivateDirectional();
	}

    PluginSdkTestProject1()
	{
		//CS Shadow:
		//patch::RedirectCall(0x56DCBA, UpdatePedShadow);
		//patch::SetUInt(0x691BE4, &EntitySetupLightingFix, 1);
		//patch::SetUChar(0x4C9CC1, 0x53);
		
		patch::SetPointer(0x691BE4, EntitySetupLightingFix); // patch for peds
		patch::SetPointer(0x691D1C, EntitySetupLightingFix); // patch for peds
		patch::SetPointer(0x691DB0, EntitySetupLightingFix); // patch for peds
		patch::SetPointer(0x692764, EntitySetupLightingFix); // patch for peds
		patch::SetPointer(0x694DA8, EntitySetupLightingFix); // patch for peds
		
		patch::SetPointer(0x69ADC8, EntitySetupLightingFix); // patch for cars
		patch::SetPointer(0x69B0EC, EntitySetupLightingFix); // patch for cars
		patch::SetPointer(0x69C254, EntitySetupLightingFix); // patch for cars
		patch::SetPointer(0x69C430, EntitySetupLightingFix); // patch for cars
		patch::SetPointer(0x69C540, EntitySetupLightingFix); // patch for cars
		patch::SetPointer(0x69CA2C, EntitySetupLightingFix); // patch for cars
		patch::SetPointer(0x6D7B6C, EntitySetupLightingFix); // patch for cars

		patch::SetPointer(0x6915C4, EntitySetupLightingFix); // patch for cutscene objects

		patch::SetPointer(0x6917D8, EntitySetupLightingFix); // patch for dynamic objects

		patch::SetPointer(0x6917DC, ObjectRemoveLightingFix); // patch for dynamic objects


		//patch::RedirectCall(0x4C9CC2, GenerateLightsAffectingObjectFix); // patch for peds
		//patch::RedirectCall(0x4C9C12, GenerateLightsAffectingObjectFix); // patch for cars
		//patch::RedirectCall(0x4C9B62, GenerateLightsAffectingObjectFix); // patch for cutscene objects

		patch::RedirectCall(0x43F61B, CPointLightsAddLightFix);
		patch::RedirectCall(0x46471F, CPointLightsAddLightFix);
		patch::RedirectCall(0x464E85, CPointLightsAddLightFix);
		patch::RedirectCall(0x465801, CPointLightsAddLightFix);
		patch::RedirectCall(0x488BD6, CPointLightsAddLightFix);
		patch::RedirectCall(0x48EBAB, CPointLightsAddLightFix);
		patch::RedirectCall(0x541ADA, CPointLightsAddLightFix);
		patch::RedirectCall(0x541B50, CPointLightsAddLightFix);
		patch::RedirectCall(0x541CD7, CPointLightsAddLightFix);
		patch::RedirectCall(0x58C53F, CPointLightsAddLightFix);
		patch::RedirectCall(0x58C8E2, CPointLightsAddLightFix);
		patch::RedirectCall(0x58E49D, CPointLightsAddLightFix);
		patch::RedirectCall(0x58E59B, CPointLightsAddLightFix);
		patch::RedirectCall(0x58E611, CPointLightsAddLightFix);
		patch::RedirectCall(0x5C4F90, CPointLightsAddLightFix);
		patch::RedirectCall(0x5C50CF, CPointLightsAddLightFix);
		patch::RedirectCall(0x5C9C6B, CPointLightsAddLightFix);
		patch::RedirectCall(0x5CBAE8, CPointLightsAddLightFix);
		patch::RedirectCall(0x5CD816, CPointLightsAddLightFix);
		patch::RedirectCall(0x5D07B1, CPointLightsAddLightFix);
		patch::RedirectCall(0x5D2252, CPointLightsAddLightFix);
		patch::RedirectCall(0x5D2848, CPointLightsAddLightFix);
		patch::RedirectCall(0x60BE6E, CPointLightsAddLightFix);
		patch::RedirectCall(0x60BF7D, CPointLightsAddLightFix);


		patch::Nop(0x4CA255, 0x05, 1); // NOP default vehicle's extra shadows' creation

		patch::Nop(0x4FE505, 0x05, 1); // NOP default ped's shadows' creation




		




		//patch::Nop(0x58E49D, 0x05, 1); // NOP default vehicle's forward pointlight creation 
		//patch::Nop(0x60BE6E, 0x05, 1); // NOP default bike's forward pointlight creation							   
									   
									   
									   
									   
	
		//patch::Nop(0x4C9C88, 0x05, 1); // TurnOffDirectionalLight for peds
		//patch::Nop(0x4C9BD8, 0x05, 1); // TurnOffDirectionalLight for cars
		//patch::Nop(0x4C9D5C, 0x05, 1); // TurnOffDirectionalLight for objects
		//patch::Nop(0x4C9B28, 0x05, 1); // TurnOffDirectionalLight for cutscene objects



		//patch::SetFloat(0x69135C, -20000.0, 1); // increase WorldBorderLeft check value
		//patch::SetFloat(0x691360, 20000.0, 1); // increase WorldBorderTop check value
		//patch::SetFloat(0x691364, -20000.0, 1); // increase WorldBorderRight check value
		//patch::SetFloat(0x691368, 20000.0, 1); // increase WorldBorderBottom check value


		//patch::Nop(0x58E3B9, 0x18, 1); // fail try1
		//patch::Nop(0x58E3BE, 0x13, 1); // fail try2
		//patch::SetFloat(0x69A6EC, 30.0, 1); // Vehicle forward pointlights range
		//patch::SetFloat(0x6D77E8, 30.0, 1); // Bike forward pointlight range
		
		 

		// PointLightPatch:
		//patch::SetChar(0x56778F, 127, 1); // max lights count





		//ololo = (unsigned int)time(0);
		//srand(ololo);
		// Initialise your plugin here
		static std::list<std::pair<unsigned int *, unsigned int>> resetEntries;
		static CPed *pVictim = nullptr;
/*#ifdef	GTAVC
		static RwTexture *savedPlayerTex = nullptr;
#endif*/

		Events::gameProcessEvent.before += []
		{
			static wchar_t  showinfo[MAX_PATH];
			
			CVector *VectorToSun = (CVector*)(0x792C70);
			CVector SunPosition;
			SunPosition.x = VectorToSun[(DWORD)(*(float *)(0xA0CFF8))].x;//0.0;
			SunPosition.y = VectorToSun[(DWORD)(*(float *)(0xA0CFF8))].y;// 0.0;
			SunPosition.z = VectorToSun[(DWORD)(*(float *)(0xA0CFF8))].z;// 50.0;
			CVector SunDirection;
			SunDirection.x = SunDirection.y = SunDirection.z = 0.0;
			float SunColorRed = (float)(*(unsigned char*)(0x9787EC) / 255.0);
			float SunColorGreen = (float)(*(unsigned char*)(0x9B6E04) / 255.0);
			float SunColorBlue = (float)(*(unsigned char*)(0xA0D920) / 255.0);
			double SunColorPower = 0.0;
			if (SunColorRed > SunColorPower) SunColorPower = SunColorRed;
			if (SunColorGreen > SunColorPower) SunColorPower = SunColorGreen;
			if (SunColorBlue > SunColorPower) SunColorPower = SunColorBlue;
			float DirColorRed = *(float*)(0x978D3C);
			float DirColorGreen = *(float*)(0xA0D058);
			float DirColorBlue = *(float*)(0xA0FC7C);
			double SunColorPower2 = 0.0;
			double SunColorPower3 = 0.0;
			if (SunPosition.z > -0.1)
			{
				SunColorPower3 = 1.0;
				if (SunPosition.z > 0.4) SunColorPower2 = 1.0;
				else
				{
					SunColorPower2 = (SunPosition.z + 0.1) / 0.5;
					if (SunPosition.z < 0.0) SunColorPower3 = (SunPosition.z + 0.1) / 0.1;
				}
			}
			double SunColorPowerMultiplier1 = SunColorPower2*2.0;
			double SunColorPowerMultiplier2 = SunColorPower2*2.0 + 1.0;
			SunColorPower = SunColorPower * SunColorPower3;
			float FinalSunColorRed = (float)((SunColorRed + DirColorRed * SunColorPowerMultiplier1) / SunColorPowerMultiplier2 * SunColorPower);
			float FinalSunColorGreen = (float)((SunColorGreen + DirColorGreen * SunColorPowerMultiplier1) / SunColorPowerMultiplier2 * SunColorPower);
			float FinalSunColorBlue = (float)((SunColorBlue + DirColorBlue * SunColorPowerMultiplier1) / SunColorPowerMultiplier2 * SunColorPower);
			SunPosition.x = (float)(SunPosition.x*5000.0);
			SunPosition.y = (float)(SunPosition.y*5000.0);
			SunPosition.z = (float)(SunPosition.z*5000.0);

			//swprintf(showinfo, MAX_PATH, L"%.1f %.1f %.1f %.1f %.1f %.1f", FinalSunColorRed, FinalSunColorGreen, FinalSunColorBlue, VectorToSun[(DWORD)(*(float *)(0xA0CFF8))].x, VectorToSun[(DWORD)(*(float *)(0xA0CFF8))].y, VectorToSun[(DWORD)(*(float *)(0xA0CFF8))].z);
			//TextHighPriority(showinfo, 1000, false);



			CPointLightsAddLightFix(5, SunPosition, SunDirection, 20000.0, FinalSunColorRed, FinalSunColorGreen, FinalSunColorBlue, 0, 1);
		};
		

		
		Events::objectRenderEvent.before += [](CObject *object)
		{
			srand(ololo);
			int pizdets = 0;
			if (pizdets == 1 && object->m_pRwClump && object->m_pRwClump->object.type == rpCLUMP)//rpATOMIC
			{
				//object->m_pRwAtomic->geometry->
				RpClumpForAllAtomics(object->m_pRwClump, [](RpAtomic *atomic, void *data)
				{
					if (atomic->geometry)
					{
						//atomic->geometry->flags |= rpGEOMETRYMODULATEMATERIALCOLOR;
						if (atomic->geometry->numVertices > 0)
						{
							if (atomic->geometry->flags & rpGEOMETRYPRELIT)
							{
								//rpGEOMETRYPOSITIONS rpGEOMETRYNORMALS rpGEOMETRYLOCKVERTICES rpGEOMETRY
								RpGeometryLock(atomic->geometry, rpGEOMETRYLOCKPRELIGHT);
								for (int i = 0; i < (atomic->geometry->numVertices); i++)
								{
									RwRGBA &color = atomic->geometry->preLitLum[i];
									color.red = 0;
									color.green = 0;
									color.blue = 255;
									color.alpha = 127;
									RwV3d &position = atomic->geometry->morphTarget->verts[i];
									//position.x = 0.0;
									//position.y = 0.0;
									position.z = 0.0;
								}
								RpGeometryUnlock(atomic->geometry);
							}
						}
					}
					return atomic;
				}, 0);
			}
			else if (pizdets == 1 && object->m_pRwAtomic && object->m_pRwAtomic->geometry && *(int*)(0x974B2C) < 65033776)
			{
				if (object->m_pRwAtomic->geometry->numVertices > 0)
				{
					if (object->m_pRwAtomic->geometry->flags & rpGEOMETRYPRELIT)
					{
						//rpGEOMETRYPOSITIONS rpGEOMETRYNORMALS rpGEOMETRYLOCKVERTICES rpGEOMETRY
						RpGeometryLock(object->m_pRwAtomic->geometry, rpGEOMETRYLOCKPRELIGHT);
						ololo = 1 + rand() % ololo;
						srand(ololo);
						unsigned int lolred = 1 + rand() % 255;
						srand(lolred);
						unsigned int lolgreen = 1 + rand() % 255;
						srand(lolgreen);
						unsigned int lolblue = 1 + rand() % 255;
						ololo = lolblue;
						for (int i = 0; i < (object->m_pRwAtomic->geometry->numVertices); i++)
						{
							RwRGBA &color = object->m_pRwAtomic->geometry->preLitLum[i];
							color.red = lolred;//255;
							color.green = lolgreen;//0;
							color.blue = lolblue;//0;
							color.alpha = 255;// 127;
							RwV3d &position = object->m_pRwAtomic->geometry->morphTarget->verts[i];
							//position.x = 0.0;
							//position.y = 0.0;
							position.z = 0.0;
						}
						RpGeometryUnlock(object->m_pRwAtomic->geometry);
					}
				}
			}
			/*else if (object->m_pRwObject && object->m_pRwObject->geometry)
			{
				if (object->m_pRwAtomic->geometry->numVertices > 0)
				{
					if (object->m_pRwAtomic->geometry->flags & rpGEOMETRYPRELIT)
					{
						//rpGEOMETRYPOSITIONS rpGEOMETRYNORMALS rpGEOMETRYLOCKVERTICES rpGEOMETRY
						RpGeometryLock(object->m_pRwAtomic->geometry, rpGEOMETRYLOCKPRELIGHT);
						for (int i = 0; i < (object->m_pRwAtomic->geometry->numVertices); i++)
						{
							RwRGBA &color = object->m_pRwAtomic->geometry->preLitLum[i];
							color.red = 255;
							color.green = 255;
							color.blue = 0;
							color.alpha = 127;
							RwV3d &position = object->m_pRwAtomic->geometry->morphTarget->verts[i];
							//position.x = 0.0;
							//position.y = 0.0;
							position.z = 0.0;
						}
						RpGeometryUnlock(object->m_pRwAtomic->geometry);
					}
				}
			}*/
		};

		Events::pedRenderEvent.before += [](CPed *ped)
		{
			int pizdets = 0;
			if (pizdets==1 &&/*ped == pVictim &&*/ ped->m_pRwClump && ped->m_pRwClump->object.type == rpCLUMP)
			{
/*#ifdef	GTAVC
				savedPlayerTex = nullptr;
				if (ped == FindPlayerPed())
				{
					savedPlayerTex = CWorld::Players[0].m_pSkinTexture;
					CWorld::Players[0].m_pSkinTexture = nullptr;
				}
#endif*/
				RpClumpForAllAtomics(ped->m_pRwClump, [](RpAtomic *atomic, void *data)
				{
					if (atomic->geometry)
					{
						//atomic->geometry->flags |= rpGEOMETRYMODULATEMATERIALCOLOR;
						//atomic->geometry->flags &= rpGEOMETRYPRELIT;
						//atomic->geometry->flags |= 1<<3; //    3
						//atomic->geometry->flags &= ~(1 << 3); //    3
						if (atomic->geometry->numVertices > 0)
						{
							if (atomic->geometry->flags & rpGEOMETRYPRELIT)
							{
								//rpGEOMETRYPOSITIONS rpGEOMETRYNORMALS rpGEOMETRYLOCKVERTICES rpGEOMETRY
								RpGeometryLock(atomic->geometry, rpGEOMETRYLOCKPRELIGHT);
								/*int testcolor;
								int *color;
								color = (int *) new (&testcolor) CRGBA(0, 255, 0, 127);
								memset(atomic->geometry->preLitLum, *color, atomic->geometry->numVertices);
								*/
								for (int i = 0; i < (atomic->geometry->numVertices); i++)
								{
									if (i < 200)
									{
										RwRGBA &color = atomic->geometry->preLitLum[i];
										color.red = 0;
										color.green = 127;
										color.blue = 0;
										//color.alpha = 127;
										RwV3d &position = atomic->geometry->morphTarget->verts[i];
										position.x = 0.0;
										position.y = 0.0;
										position.z = 0.0;

										//atomic->geometry->morphTarget->normals
										//atomic->geometry->morphTarget->boundingSphere
										//atomic->geometry->morphTarget->parentGeom
									}
								}
								RpGeometryUnlock(atomic->geometry);
							}
							
							/*RpGeometryForAllMaterials(atomic->geometry, [](RpMaterial *material, void *data)
							{
								resetEntries.push_back(std::make_pair(reinterpret_cast<unsigned int *>(&material->color), *reinterpret_cast<unsigned int *>(&material->color)));
								material->color = { 0, 255, 0, 127 };
								resetEntries.push_back(std::make_pair(reinterpret_cast<unsigned int *>(&material->texture), *reinterpret_cast<unsigned int *>(&material->texture)));
								material->texture = 0;
								return material;
							}, 0);*/
						}
						//atomic->geometry->flags |= 1 << 5;
						//atomic->geometry->flags &= ~(1 << 3); //    3
					}
					return atomic;
				}, 0);
				//DeActivateDirectional();
				//SetFullAmbient();
			}
			/*CCutsceneShadow *pShadow = pedShadow.Get(ped).m_pRTShadow;
			if (!pShadow)
			{
				//PedShadow &shadow = pedShadow.Get(ped);
				//if (!shadow.m_pRTShadow)
				//{
					pShadow = new CCutsceneShadow;
					pShadow->Create(ped->m_pRwObject, 7, 1, 1, 1);
				//}

			}*/






		};

/*		Events::pedRenderEvent.after += [](CPed *ped)
		{
			for (auto &p : resetEntries)
				*p.first = p.second;
			resetEntries.clear();
#ifdef	GTAVC
			if (savedPlayerTex)
				CWorld::Players[0].m_pSkinTexture = savedPlayerTex;
#endif
		};*/

		/*Events::gameProcessEvent += []
		{
			pVictim = FindPlayerPed();
			
			
			if (trololo == 1)
			{
				if (*(int*)(0x974B2C) > 65033776)
				{
					//plugin::Call<0x4A4850>();//CGame::ReInitGameObjectVariables()
					//plugin::Call<0x4A47B0>();//CGame::ShutDownForRestart()
					//plugin::Call<0x4A4670>();//CGame::InitialiseWhenRestarting()
					
					//plugin::Call<0x625060>();//CReplay::Init(void)
					trololo = 0;
				}
			}
		};*/

		//CS Shadows:
		//Events::pedSetModelEvent += CreatePedShadow;
		
		
		/*Events::d3dResetEvent += []
		{
			if (*(int*)(0x974B2C) > 5000)//(*(char*)(0x9B5F08) == 9)
			{
				//if(*(int*)(0x974B2C) > 65033776)
				//plugin::Call<0x625060>();//CReplay::Init(void)
				trololo = 1;
				//plugin::Call<0x4A4850>();//CGame::ReInitGameObjectVariables()
				//plugin::Call<0x4A47B0>();//CGame::ShutDownForRestart()
				//plugin::Call<0x4A4670>();//CGame::InitialiseWhenRestarting()
			}
			//CReplay::Init();
			//patch::RedirectCall(0x56DCBA, UpdatePedShadow);
		};*/
    }
} pluginSdkTestProject1;


//PedExtendedData<PluginSdkTestProject1::PedShadow> PluginSdkTestProject1::pedShadow;